
// The code below uses require.js, a module system for javscript:
// http://requirejs.org/docs/api.html#define

require.config({ 
    baseUrl: 'js/lib',
    paths: {'jquery':
            ['//ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min',
             'jquery']},

});

// Include the in-app payments API, and if it fails to load handle it
// gracefully.
// https://developer.mozilla.org/en/Apps/In-app_payments
require(['https://marketplace.cdn.mozilla.net/mozmarket.js'],
        function() {},
        function(err) {
            window.mozmarket = window.mozmarket || {};
            window.mozmarket.buy = function() {
                alert('The in-app purchasing is currently unavailable.');
            };
        });

// Include tabzilla
require(['//www.mozilla.org/tabzilla/media/js/tabzilla.js']);
// Include mozilla site js
require(['//www.mozilla.org/media/js/site-min.js']);
require(['//www.mozilla.org/media/js/mozorg-resp-min.js']);

// When you write javascript in separate files, list them as
// dependencies along with jquery
define("app", function(require) {

    require(['jquery'], function($){
    	require(['js/client-notices.js']);
    });
	var $ = jQuery;
    // If using Twitter Bootstrap, you need to require all the
    // components that you use, like so:
    // require('bootstrap/dropdown');
    // require('bootstrap/alert');


    // START HERE: Put your js code here
    // notify animation
//    $(function(){
//    	$('#notify').slideToggle('slow', function(){
//    		$(this).click(function(){
//    			$(this).slideToggle('slow');
//    		});
//    	});
//    });

	// starring session action (list)
	$(function(){
		$('.indicator').click(function(e){
			if($(this).hasClass('starred'))	{
				$(this).removeClass('starred');
			}
			else {
				$(this).addClass('starred');
			}
			
			// fixes selection bug
			if (window.getSelection) {
				if (window.getSelection().empty) {  // Chrome
					window.getSelection().empty();
				} else if (window.getSelection().removeAllRanges) {  // Firefox
					window.getSelection().removeAllRanges();
				}
			} else if (document.selection) {  // IE?
				document.selection.empty();
			}
		});
	});
	
	// unstarring session (starred page)
	$(function(){
		$('#starred .indicator.starred').click(function(e){
			if(confirm('Are you sure you want to stop tracking "' + $(this).parent().text() + '"?')) {
				$(this).parents('li').eq(0).fadeOut('slow');
			}
			else {
				$(this).addClass('starred');
				return false;
			}
		});
	});





    // Hook up the installation button, feel free to customize how
    // this works
    
    var install = require('install');

    function updateInstallButton() {
        $(function() {
            var btn = $('.install-btn');
            if(install.state == 'uninstalled') {
                btn.show();
            }
            else if(install.state == 'installed' || install.state == 'unsupported') {
                btn.hide();
            }
        });
    }

    $(function() {
        $('.install-btn').click(install);        
    });

    install.on('change', updateInstallButton);

    install.on('error', function(e, err) {
        // Feel free to customize this
        $('.install-error').text(err.toString()).show();
    });

    install.on('showiOSInstall', function() {
        // Feel free to customize this
        var msg = $('.install-ios-msg');
        msg.show();
        
        setTimeout(function() {
            msg.hide();
        }, 8000);
    });

});
